#!/bin/sh
#Interfaz Xdialog para "proteger" (pasar a owned garraxi2) los archivos y subdirs de /Musica y /Kunuyas.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variables utiles (paths y tal, para pruebas sobre todo):
#BILTEGI=/home/martintxo/pruebas/garraxi/
BILTEGI=/home/garraxi/Biltegi/
#DIRPROGRAMAS=/home/martintxo/pruebas/garraxi
DIRPROGRAMAS=/home/garraxi/Biltegi/Programas
#SOY=root
SOY=garraxi2
#Los archivos/directorios protegidos son propiedad de garraxi2
#USERBAK=prueba
USERBAK=garraxi2
#Los archivos/directorios en dirs Programas/Emision son propiedad de garraxi
#USERPROG=martintxo
USERPROG=garraxi

#Para comprobar que es garraxi2 el que ejecuta el script (si no es exit, si es continua...):
QUIENSOY=`whoami`;
if [ "$QUIENSOY" != "$SOY" ];then
Xdialog --wmclass "soma" --title "Usuario no autorizado" --icon /usr/local/share/pixmaps/warning.xpm \
        --msgbox "Me parece que tu no eres el Administrador de la Emisin.\nAbortando..." 0 0;
exit;
fi

# para parsear correctamente los espacios en los nombres de archivo:
#$IFS (Input Field Separators) indica el separador utilizado, y el estandar en bash es un espacio, lo cambiamos
OLDIFS=$IFS
IFS=

# Funcion que elige el directorio:
directorio()
{
    DIR=`Xdialog --wmclass "soma" --title "Proteger msica/kuas"  --no-buttons --stdout \
       --backtitle "Elige la carpeta que quieres proteger (solo se puede una).\nDespus dale al OK y espera un rato.\nCuando haya terminado aparecer una ventana con resultados." \
        --dselect "$BILTEGI" 0 0`;
    case $? in
    0)	
    echo "$DIR" | grep "$BILTEGI"
    ;;
    1)
    exit;;
    esac   
}

# Funcion que hace el "trabajpo sucio" y presenta los resultados:
curra()
{
 rm -f /tmp/garraxi2-chown.log;
 touch /tmp/garraxi2-chown.log;
 #ver que ficheros NO son de garraxi2, cambiar permisos a rw-rw-r-- y pasar a garraxi2:
 for i in $(find "$DIR" -type f -user "$USERPROG" -printf "%p$IFS")
 do
 sudo chmod -v u=rw,g=rw,o=r "$i" >> /tmp/garraxi2-chown.log &
 sudo chown -v "$USERBAK":"$USERBAK" "$i" >> /tmp/garraxi2-chown.log &
 done

 #ver que dirs NO son de garraxi2, cambiar permisos a rwxrwxrwt y pasar a garraxi2:
 # pongo sticky bit y cualquiera puede guardar archivos pero solo el dueo (garraxi2) puede borrarlos. 
 for i in $(find "$DIR" -mindepth 1 -type d -user "$USERPROG" -printf "%p$IFS")
 do
 sudo chmod -v u=rwx,g=rwx,o=rwxt "$i" >> /tmp/garraxi2-chown.log &
 sudo chown -v "$USERBAK":"$USERBAK" "$i" >> /tmp/garraxi2-chown.log &
 done
 
 #No se puede "proteger" los archivos de programas en emision porque si no no se pueden mover a su dir de backup
 # (los dir de emision si se pueden proteger, porque van con sticky bite).
 # Si que protegemos los antiguos en backup, y solo los podra borrar un admin.
 for i in $(find "$DIRPROGRAMAS/Emision" -type f -printf "%p$IFS")
 do 
 sudo chown "$USERPROG":"$USERPROG" $i
 done

  Xdialog --title "Resultados proteccin" --smooth --no-cancel --wmclass "soma" \
          --backtitle "Resultados:\n\"Archivo: cambia a 0664...\" -> permisos correctos para archivo.\n\"Directorio: cambia a 1777...\" -> permisos correctos para directorio.\n\"cambiado el propietario...\" -> xito en proteccin.\nOtro resultado: infrmame (martintxo@sindominio.net)" \
           --tailbox /tmp/garraxi2-chown.log 25 100;

  Xdialog --wmclass "soma" --title "Proteger msica/kuas" --timeout 10 \
     --msgbox "Proteccin terminada.\nGracias por colaborar en la administracin de Garraxi." 0 0;
}

#Pregunta inicial de si proteger musica o no:
Xdialog --wmclass "soma" --title "Proteger msica/kuas" --left \
        --backtitle "Quieres proteger la msica y/o cuas de la Garraxi?" \
       --yesno "Antes de hacerlo, mira un poco cuantas carpetas hay sin proteger,\ny si hay carpetas o archivos duplicados.\nDespus, en la siguiente ventana, elige la carpeta (y subcarpetas)\nque quieras proteger." 0 0

#Si respuesta es SI: elegir directorios, protegerlos, sacar output en pantalla
#Si respuesta es NO: sale sin hacer nada
case $? in
  0)
     directorio
        #Si el dir elegido esta en el path permitido, curra, si no mensaje:
	  if [ $? -eq 0 ];then
          curra
          else
          Xdialog --wmclass "soma" --title "Proteger msica/kuas" --icon /usr/local/share/pixmaps/warning.xpm \
                  --msgbox "Creo que te has equivocado y has elegido una carpeta no permitida.\nVuelve a intentarlo..." 0 0;
                   directorio
		     if [ $? -eq 0 ];then
                       curra
                     else
		       Xdialog --wmclass "soma" --title "Proteger msica/kuas" --icon /usr/local/share/pixmaps/warning.xpm \
                               --msgbox "Es la 2 vez que te \"equivocas\".\nAbortando..." 0 0;
		       exit;
		     fi
          fi
;;
  1)
    exit;;
esac

#Por si acaso, reponemos el separador estandar de bash:
IFS=$OLDIFS
